# Annotation Glossary

### A

allow-none

  NULL is OK, both for passing and for returning.

array

  Parameter points to an array of items.

### C

closure

  This parameter is a 'user_data', for callbacks; many bindings can pass NULL here.

constructor

  This symbol is a constructor, not a static method.

### E

element-type

  Generics and defining elements of containers and arrays.

### I

in

  Parameter for input. Default is transfer none.

inout

  Parameter for input and for returning results. Default is transfer full.

### M

method

  This is a method

### N

not nullable

  NULL must not be passed as the value in, out, in-out; or as a return value.

nullable

  NULL may be passed as the value in, out, in-out; or as a return value.

### O

optional

  NULL may be passed instead of a pointer to a location.

out

  Parameter for returning results. Default is transfer full.

out caller-allocates

  Out parameter, where caller must allocate storage.

### R

rename-to

  Rename the original symbol's name to SYMBOL.

### S

scope async

  The callback is valid until first called.

scope call

  The callback is valid only during the call to the method.

skip

  Exposed in C code, not necessarily available in other languages.

### T

transfer container

  The caller owns the data container, but not the data inside it.

transfer full

  The caller owns the data, and is responsible for free it.

transfer none

  The data is owned by the callee, which is responsible of freeing it.

type

  Override the parsed C type with given type.

### V

virtual

  This is the invoker for a virtual method.